package ru.bgcrm.dyn;

import org.apache.log4j.Logger;
import ru.bgcrm.dao.message.MessageTypeCall;
import ru.bgcrm.dao.message.config.MessageTypeConfig;
import ru.bgcrm.event.Event;
import ru.bgcrm.event.RunClassRequestEvent;
import ru.bgcrm.event.listener.DynamicEventListener;
import ru.bgcrm.model.BGException;
import ru.bgcrm.model.message.Message;
import ru.bgcrm.struts.form.DynActionForm;
import ru.bgcrm.util.Setup;
import ru.bgcrm.util.sql.ConnectionSet;
import ru.bgcrm.util.sql.SQLUtils;

import java.sql.Connection;
import java.util.Date;

/**
 * Пример запроса от 3cx 
 * https://crm.zetlink.ru/admin/dynamic.do?action=runDynamicClass&iface=event&class=ru.bgcrm.dyn.ExampleHttpCall&j_username=apitestw&j_password=apitest&contact=9148544920&authToSession=0
*/

public class ExampleHttpCallJournal extends DynamicEventListener {
	private static final Logger log = Logger.getLogger(ExampleHttpCallJournal.class);

	private final MessageTypeCall messageType;

	public ExampleHttpCallJournal() {
		messageType = null;
	}

	public void MessageTypeCallRegister() {}

	@Override
	public void notify(Event e, ConnectionSet connectionSet) throws BGException {
		RunClassRequestEvent event = (RunClassRequestEvent) e;

		String from = event.getForm().getParam("number");
		String to = event.getForm().getParam("agent");
		String call_subject = event.getForm().getParam("callsubject", "TEST");
		log.info("Получен запрос с number=" + from + ", extension=" + to + ", тема: " + call_subject);

		MessageTypeCall messageType = (MessageTypeCall) Setup.getSetup().getConfig(MessageTypeConfig.class).getTypeMap()
				.get(4);
		if (messageType == null) {
			throw new BGException("Не найден тип сообщения.");
		}
		
		log.info("message....");
		//MessageTypeCall.CallRegistration reg = messageType.getRegistrationByUser("100");
		log.info("try");
		try {

			Connection con = Setup.getSetup().getDBConnectionFromPool();
			try {
				MessageTypeCall.CallRegistration reg = messageType.getRegistrationByNumber(to);
				if (reg != null)
					log.info("Call to registred number: " + reg.getNumber());

				Message message = new Message();
				message.setDirection(Message.DIRECTION_INCOMING);
				message.setTypeId(messageType.getId());
				message.setUserId(1);
				message.setText("");
				message.setFrom(from);
				message.setTo(to);
				message.setSubject(call_subject);
				message.setFromTime(new Date());
				message.setSystemId(messageType.getId() + ":" + System.currentTimeMillis());
				message.setProcessed(true);

				// по сути там вызывается просто MessageDAO, сделано для единообразия
				messageType.updateMessage(con, DynActionForm.SERVER_FORM, message);

				con.commit();

				if (reg != null)
                    			reg.setMessageForOpenId(message.getId());

				event.getForm().setResponseType("application/json;charset=UTF-8");
				event.getForm().setResponseData("id", message.getId());
			} catch (Exception ex) {

			} finally {
				SQLUtils.closeConnection(con);
			}

		} catch (Exception exception) {
			exception.printStackTrace();
		}
	}
}

